#define USE_TI89
#define USE_V200
#define OPTIMIZE_ROM_CALLS
#define MIN_AMS 100
#define SAVE_SCREEN

#include <tigcclib.h>
#define NUMICONS 10
static unsigned char diamond[]=			{0x10,0x38,0x5c,0x9e,0xbe,0xfe,0xfe,0x7c,0x38,0x10};
static unsigned char exclimation[]=	{0x38,0x4c,0x5c,0x7c,0x38,0x38,0x10,0x00,0x38,0x38};
static unsigned char apple[]=				{0x60,0x10,0x6c,0x92,0x82,0x92,0x92,0x82,0x54,0x28};
static unsigned char tack[]=				{0x7c,0x64,0x28,0x28,0x44,0xc2,0xfe,0x10,0x10,0x10};
static unsigned char clock[]=				{0x00,0x38,0x44,0x92,0x92,0x8a,0x44,0x38,0x00,0x00};
static unsigned char band[]=				{0x0e,0x88,0x6a,0x88,0x6a,0x88,0xba,0x78,0x7a,0x32};
static unsigned char pencil[]=			{0x7c,0x82,0xFE,0xfe,0xaa,0xaa,0xaa,0x44,0x38,0x10};
static unsigned char paper[]=				{0xf0,0x98,0x94,0x9e,0x82,0xba,0x82,0xba,0x82,0xfe};
static unsigned char question[]=		{0x3c,0x7e,0x66,0x66,0x0e,0x1c,0x18,0x00,0x18,0x18};
static unsigned char person[]=			{0x38,0x38,0xba,0x92,0x7c,0x38,0x38,0x28,0x28,0x6c};


static void *icons[]={diamond,exclimation,apple,tack,clock,band,pencil,paper,question,person};
static unsigned long selector[]={0xfffff800,0xfffff800,0xfffff800,0xfffff800,0xfffff800,0xfffff800,0xfffff800,0xfffff800,0xfffff800,0xfffff800,0xfffff800,0xfffff800};
const char *monthName[12]={"January","February","March","April","May","June","July","August","September","October","November","December"};
const char *dayOfWeek[7]={"Sunday","Monday","Tuesday","Wedensday","Thursday","Friday","Saturday"};
	
//////////////////////////////////////////////////////////////////////////////////////////

typedef struct {
	int year;
	char month;
	char day;
	char icon;
	unsigned char textLength;
	HANDLE textBuffer;
	void *next;
} entry;

//////////////////////////////////////////////////////////////////////////////////////////

static int month=1;
static int year=2000;
static int day=1;

int numEntries=0;
entry *entries=NULL;
void *virtual;
//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
entry *insertNode(entry *n1,entry *n2){
	entry *new=malloc(sizeof(entry));
	if(new==NULL) return NULL;
	if(n2!=NULL){new->next=n2;}else{new->next=NULL;}
	if(n1!=NULL){n1->next=new;}else{entries=new;}
	return new;
}
//////////////////////////////////////////////////////////////////////////////////////////
int monthSize(int m,int y){
	char days[12]={31,28,31,30,31,30,31,31,30,31,30,31};
	if(!(y%4) && m==1){
		return 29;
	}else{
		return (int)days[m];
	}
}
//////////////////////////////////////////////////////////////////////////////////////////
int init(){
	int i;
	entry *temp=NULL;
	SYM_ENTRY *sym;
	ESQ type;
	clrscr();
	printf_xy(45,45,"Loading...");
	FILE *file=fopen("calendat","rb");
	sym=SymFindPtr(SYMSTR("calendat"),0);
	type=*(HToESI(sym->handle));
	
	entries=NULL;
	if(file==NULL){
		numEntries=0;
		return 0;
	}
	if(type!=OTH_TAG)																											return 1;
	
	if(!(fread(&numEntries,sizeof(numEntries),1,file)))										return 1;
		
	for(i=0;i<numEntries;i++){
		temp=insertNode(temp,NULL);
		if(temp==NULL)																											return 5;
		if(!(fread(&temp->year,				sizeof(temp->year)				,1,file)))	return 1;
		if(!(fread(&temp->month,			sizeof(temp->month)				,1,file)))	return 1;
		if(!(fread(&temp->day,				sizeof(temp->day)					,1,file)))	return 1;
		if(!(fread(&temp->icon,				sizeof(temp->icon)				,1,file)))	return 1;
		if(!(fread(&temp->textLength,	sizeof(temp->textLength)	,1,file)))	return 1;
		temp->textBuffer=HeapAlloc(temp->textLength);
		if(temp->textBuffer==H_NULL)																				return 1;
		if(!(fread(HeapDeref(temp->textBuffer),1,temp->textLength,file)))		return 1;
	}
	fclose(file);
	
	return 0;
}
/////////////////////////////////////////////////////////////////////////////////////////
void freeMem(){
	entry *temp;
	while(entries!=NULL){
		temp=entries;
		HeapFree(entries->textBuffer);
		entries=entries->next;
		free(temp);
	}
}
//////////////////////////////////////////////////////////////////////////////////////////
int shutdown(){
	int i;
	entry *temp=entries;
	numEntries=0;
	clrscr();
	printf_xy(48,45,"Saving...");
	FILE *file=fopen("calendat","wb");
	
	if(file==NULL)																												return 3;
	if(!(fwrite(&numEntries,sizeof(numEntries),1,file)))									return 2;	
	
	for(i=0;i<numEntries;i++){
		if(!(fwrite(&temp->year,			sizeof(temp->year)				,1,file)))	return 2;
		if(!(fwrite(&temp->month,			sizeof(temp->month)				,1,file)))	return 2;
		if(!(fwrite(&temp->day,				sizeof(temp->day)					,1,file)))	return 2;
		if(!(fwrite(&temp->icon,			sizeof(temp->icon)				,1,file)))	return 2;
		if(!(fwrite(&temp->textLength,sizeof(temp->textLength)	,1,file)))	return 2;
		if(!(fwrite(HeapDeref(temp->textBuffer), 1, temp->textLength	,file)))	return 2;
		temp=temp->next;
	}
	fputc(0,file);
	fputs("DAT",file);
	fputc(0,file);
	fputc(OTH_TAG,file);
	fclose(file);
	freeMem();

	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////
void dispError(int error){
	clrscr();
	FontSetSys(F_4x6);
	switch(error){
		case 1:printf("Error Reading File\nProbably Corrupt\nBetter Delete It\nFile Must be calendat.DAT\n\n"); break;
		case 2:printf("Error Writing File\nOut Of Mem????\n\n"); break;
		case 3:printf("Error Opening File For Writing\nIt Might Be Archived\nUnarchive It\n\n"); break;
		case 5:printf("Failed To Create A New Entry\nOut Of Mem\nOr Too Many Entries\n\n");break;
	}
	ngetchx();
}
//////////////////////////////////////////////////////////////////////////////////////////
int findMonthData(entry **monthData){
	int num=0;
	entry *temp;
	(*monthData)=entries;
	while((*monthData)!=NULL && ((*monthData)->month!=month || (*monthData)->year!=year)){
		(*monthData)=(*monthData)->next;
	}
	temp=(*monthData);	
	while(temp!=NULL && temp->month==month && temp->year==year){
		num++;
		temp=temp->next;
	}
	return num;
}
//////////////////////////////////////////////////////////////////////////////////////////
int startDay(){
	int fdy,x=0,fdm,conv[7]={0,5,3,1,6,4,2};
	
	fdy=((conv[(int)floor(((double)(year%28)/4)-0.25)]+((year-1)%4))%7);	
	
	while(x<month){
		fdy+=monthSize(x,year);
		x++;
	}
	fdm=(fdy%7);
	return fdm;
}
//////////////////////////////////////////////////////////////////////////////////////////
void invertCursor(int d){
	int cell=(startDay()+(d-1));
	Sprite32(22*(cell%7)+3,13*(cell/7)+22,12,selector,LCD_MEM,SPRT_XOR);
}
//////////////////////////////////////////////////////////////////////////////////////////
void drawCalendar(){
	int x,i,numInMonth,tx=22*startDay()+3,ty=23,numDays=monthSize(month,year);
	entry *monthData=NULL;
	
	numInMonth=findMonthData(&monthData);
	clrscr();
	FontSetSys(F_4x6);
	printf_xy(4,15," SUN    MON    TUE     WED    THU      FRI     SAT");
	DrawLine(0,0,159,0,A_NORMAL);
	DrawLine(0,13,159,13,A_NORMAL);
	for(x=2;x<160;x+=22)
		DrawLine(x,13,x,99,A_NORMAL);
	for(x=99;x>20;x-=13)
		DrawLine(2,x,156,x,A_NORMAL);
	
	FontSetSys(F_8x10);
	printf_xy(2,2,"%s",monthName[month]);
	printf_xy(125,2,"%d",year);
	FontSetSys(F_6x8);
	
	for(x=0,i=0;x<numDays;x++){
		printf_xy(tx,ty,"%d",x+1);
		if(i<numInMonth && monthData->day==(x+1)){
			Sprite8(tx+13,ty,10,icons[(int)monthData->icon],LCD_MEM,SPRT_XOR);
			i++;
			monthData=monthData->next;
		}
		tx+=22;
		if(tx>=154){
			tx=3;
			ty+=13;
		}
	}
	invertCursor(day);
}
//////////////////////////////////////////////////////////////////////////////////////////

void adjustYear(int y){
	if(y<-32000 || y>32000) year=2000;
}

//////////////////////////////////////////////////////////////////////////////////////////
void adjustMonth(int m){
	if(m<0){
		month=11;
		adjustYear(--year);
	}else if(m>=12){
		month=0;
		adjustYear(++year);
	}
}
//////////////////////////////////////////////////////////////////////////////////////////
entry *getEntry(){
	entry *new,*temp=entries,*prev=NULL;
	while(	temp!=NULL && 
					((year>temp->year) ||
					(year==temp->year && month>temp->month) ||
					(year==temp->year && month==temp->month && day>=temp->day))){
		if(year==temp->year && month==temp->month && day==temp->day)
			return temp;
		prev=temp;	
		temp=temp->next;
	}
	new=insertNode(prev,temp);
	new->year=year;
	new->month=month;
	new->day=day;
	new->icon=0;
	new->textLength=0;
	new->textBuffer=HeapAlloc(10);
	memset(HeapDeref(new->textBuffer),0,1);	
	numEntries++;
	return new;
}
//////////////////////////////////////////////////////////////////////////////////////////
void enter(){
	char titleStr[30];
	int len,k=0;
	entry *data;
	EVENT ev;
	TEXT_EDIT te;
	data=getEntry();
	len=sprintf(titleStr,"%s, %s %d",dayOfWeek[(startDay()+(day-1))%7],monthName[month],day);
	clrscr();
	DrawLine(0,0,159,0,A_NORMAL);
	DrawLine(0,17,159,17,A_NORMAL);
	DrawLine(0,93,159,93,A_NORMAL);
	FontSetSys(F_6x8);
	printf_xy((int)(160-6*len)/2,2,"%s",titleStr);
	FontSetSys(F_4x6);
	printf_xy(72,11,"%d",year);
	printf_xy(50,95,"F1/F2-ChIcon   |   ESC-Save&Exit");

	Sprite8(1,3,10,icons[(int)data->icon],LCD_MEM,SPRT_XOR);
	
	TE_open(&te,DeskTop,MakeWinRect(0,19,160,92),data->textBuffer,0,0,3);
	CU_start();
	while(k!=KEY_ESC){
		FontSetSys(F_4x6);printf_xy(0,95,"%d Chars",te.CurSize);	
		k=EV_getc(ACTIVITY_BUSY,&ev);
	  if(k==KEY_F1){
	  	Sprite8(1,3,10,icons[(int)data->icon],LCD_MEM,SPRT_XOR);
	  	data->icon=(data->icon+1)%NUMICONS;
	  	Sprite8(1,3,10,icons[(int)data->icon],LCD_MEM,SPRT_XOR);
	  }else if(k==KEY_F2){
	  	Sprite8(1,3,10,icons[(int)data->icon],LCD_MEM,SPRT_XOR);
	  	data->icon=(data->icon+9)%NUMICONS;
	  	Sprite8(1,3,10,icons[(int)data->icon],LCD_MEM,SPRT_XOR);
	  }else if(k!=KEY_ESC)	TE_handleEvent (&te, &ev);
  }
	data->textLength=te.CurSize+1;
	drawCalendar();
}
//////////////////////////////////////////////////////////////////////////////////////////
void deleteNode(){
	entry *temp=entries,*prev=NULL;
	int found=0;
	while(temp!=NULL && !found){
		if(temp->year==year && temp->month==month && temp->day==day){
			if(prev==NULL){
				entries=temp->next;
			}else{
				prev->next=temp->next;
			}
			HeapFree(temp->textBuffer);
			free(temp);
			numEntries--;
			found=1;
		}else{
			prev=temp;
			temp=temp->next;
		}
	}
	drawCalendar();
}
//////////////////////////////////////////////////////////////////////////////////////////
void _main(void) {
	int error,k=0,oldyear=-1,oldmonth=-1,oldday=-1;
	
	if((error=init())){
		dispError(error);
		freeMem();
		return;
	}
	
	while(k!=KEY_ESC){
		switch(k){
			case 337:				day-=7;				break;
			case 340:				day+=7;				break;
			case 338:				day--;				break;
			case 344:				day++;				break;
			case 4433:			year++;				break;
			case 4436:			year--;				break;
			case 4434:			month--;			break;
			case 4440:			month++;			break;
			case 13:				enter();			break;
			case 257:				deleteNode();	break;
		}
		adjustMonth(month);
		adjustYear(year);
		if(day<1){
			adjustMonth(--month);
			day+=monthSize(month,year);
		}else if(day>monthSize(month,year)){
			day-=monthSize(month,year);
			adjustMonth(++month);
		}
		if(year!=oldyear || month!=oldmonth){
			drawCalendar();
		}else if(day!=oldday){
			invertCursor(oldday);
			invertCursor(day);
		}
		k=ngetchx();
		oldyear=year;
		oldmonth=month;
		oldday=day;
		
	}
	if((error=shutdown()))
		dispError(error);
	
	
}
